<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.playlet.system.mapper.PublicDetailCommentMapper">

    <resultMap type="PublicDetailComment" id="PublicDetailCommentResult">
        <result property="id"    column="id"    />
        <result property="detailId"    column="detail_id"    />
        <result property="userId"    column="user_id"    />
        <result property="userName"    column="user_name"    />
        <result property="imgUrl"    column="img_url"    />
        <result property="content"    column="content"    />
        <result property="starCount"    column="star_count"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
        <result property="topStatus"    column="top_status"    />
    </resultMap>

    <sql id="selectPublicDetailCommentVo">
        select id, detail_id, user_id, user_name, top_status, img_url, content, star_count, create_by, create_time, update_by, update_time, remark from public_detail_comment
    </sql>

    <select id="selectPublicDetailCommentList" parameterType="PublicDetailComment" resultMap="PublicDetailCommentResult">
        <include refid="selectPublicDetailCommentVo"/>
        <where>
            <if test="detailIds != null and detailIds.size() > 0">
                and detail_id in
                <foreach item="item" collection="detailIds" open="(" separator="," close=")">
                    #{item}
                </foreach>
            </if>
            <if test="detailId != null "> and detail_id = #{detailId}</if>
            <if test="userId != null "> and user_id = #{userId}</if>
            <if test="userName != null  and userName != ''"> and user_name like concat('%', #{userName}, '%')</if>
            <if test="content != null  and content != ''"> and content = #{content}</if>
            <if test="starCount != null "> and star_count = #{starCount}</if>
            <if test="isResponse == '02'">
                and remark is not null
            </if>
            <if test="isResponse == '01'">
                and remark is null
            </if>
        </where>
        order by create_time desc
    </select>

    <select id="selectPublicDetailCommentById" parameterType="Long" resultMap="PublicDetailCommentResult">
        <include refid="selectPublicDetailCommentVo"/>
        where id = #{id}
    </select>

    <insert id="insertPublicDetailComment" parameterType="PublicDetailComment" useGeneratedKeys="true" keyProperty="id">
        insert into public_detail_comment
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="detailId != null">detail_id,</if>
            <if test="userId != null">user_id,</if>
            <if test="userName != null">user_name,</if>
            <if test="content != null">content,</if>
            <if test="starCount != null">star_count,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="detailId != null">#{detailId},</if>
            <if test="userId != null">#{userId},</if>
            <if test="userName != null">#{userName},</if>
            <if test="content != null">#{content},</if>
            <if test="starCount != null">#{starCount},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
        </trim>
    </insert>

    <update id="updatePublicDetailComment" parameterType="PublicDetailComment">
        update public_detail_comment
        <trim prefix="SET" suffixOverrides=",">
            <if test="detailId != null">detail_id = #{detailId},</if>
            <if test="userId != null">user_id = #{userId},</if>
            <if test="userName != null">user_name = #{userName},</if>
            <if test="content != null">content = #{content},</if>
            <if test="starCount != null">star_count = #{starCount},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deletePublicDetailCommentById" parameterType="Long">
        delete from public_detail_comment where id = #{id}
    </delete>

    <delete id="deletePublicDetailCommentByIds" parameterType="String">
        delete from public_detail_comment where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>

</mapper>